import { Block } from '@ensi-platform/core-components';
import { useCallback, useMemo } from 'react';

import { useCatalogBulkOperations, useCatalogBulkOperationsMeta } from '@api/catalog';
import { CatalogBulkOperation } from '@api/catalog/types/bulk-operations';

import { useError } from '@context/modal';

import AutoFilters from '@components/AutoFilters';
import PageWrapper from '@components/PageWrapper';
import Table, { TooltipItem, useSorting, useTable } from '@components/Table';
import { getSettingsColumn } from '@components/Table/columns/getSettingsColumn';
import { TableEmpty, TableFooter, TableHeader } from '@components/Table/components';

import { scale, typography } from '@scripts/gds';
import { declOfNum, getTotal, getTotalPages } from '@scripts/helpers';
import { useRedirectToNotEmptyPage, useTableList } from '@scripts/hooks';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';
import { useGoToDetailPage } from '@scripts/hooks/useGoToDetailPage';

import { useCatalogAccess } from '../catalog/scripts/hooks';

const MassEditHistory = () => {
    const {
        ID: { editProperties: canEditProperties },
    } = useCatalogAccess();

    const { data: apiMeta, error: metaError } = useCatalogBulkOperationsMeta(canEditProperties);
    useError(metaError);

    const meta = apiMeta?.data;

    const {
        metaField,
        values,
        filtersActive,
        URLHelper,
        searchRequestFilter,
        emptyInitialValues,
        codesToSortKeys,
        clearInitialValue,
        reset,
    } = useAutoFilters(meta);

    const pageKey = 'mass-edit-history';

    const [{ backendSorting }, sortingPlugin] = useSorting<CatalogBulkOperation>(pageKey, meta?.fields);

    const { activePage, itemsPerPageCount, setItemsPerPageCount } = useTableList({
        defaultSort: meta?.default_sort,
        codesToSortKeys,
    });

    const {
        data,
        isFetching: isLoading,
        error,
    } = useCatalogBulkOperations(
        {
            sort: backendSorting,
            filter: searchRequestFilter,
            pagination: { type: 'offset', limit: itemsPerPageCount, offset: (activePage - 1) * itemsPerPageCount },
        },
        Boolean(meta) && !!backendSorting
    );

    useError(error);

    const rows = useAutoTableData<CatalogBulkOperation>(data?.data, metaField);

    const autoGeneratedColumns = useAutoColumns(meta, false);

    const total = getTotal(data);
    const totalPages = getTotalPages(data, itemsPerPageCount);

    useRedirectToNotEmptyPage({ activePage, itemsPerPageCount, total });

    const renderHeader = useCallback(
        () => (
            <TableHeader css={{ paddingLeft: 0, paddingRight: 0 }}>
                <div css={{ display: 'flex', justifyContent: 'space-between', width: '100%', padding: 0 }}>
                    <p css={{ lineHeight: '32px', ...typography('bodySm') }}>
                        Найдено{' '}
                        {`${total} ${declOfNum(total, [
                            'массовая операция',
                            'массовые операции',
                            'массовых операций',
                        ])}`}
                    </p>
                </div>
            </TableHeader>
        ),
        [total]
    );

    const goToDetailPage = useGoToDetailPage();

    const tooltipContent: TooltipItem[] = useMemo(
        () => [
            {
                type: 'edit',
                text: 'Перейти в детальную страницу',
                action: goToDetailPage,
            },
        ],
        [goToDetailPage]
    );

    const columns = useMemo(
        () => [
            ...autoGeneratedColumns,
            getSettingsColumn({ columnsToDisable: [], visibleColumns: meta?.default_list, tooltipContent }),
        ],
        [autoGeneratedColumns, meta?.default_list]
    );

    const table = useTable(
        {
            data: rows,
            columns,
            meta: {
                tableKey: pageKey,
            },
        },
        [sortingPlugin]
    );

    return (
        <PageWrapper h1="История массовых изменений товаров" isLoading={isLoading} isForbidden={!canEditProperties}>
            <AutoFilters
                initialValues={values}
                emptyInitialValues={emptyInitialValues}
                onSubmit={URLHelper}
                filtersActive={filtersActive}
                css={{ marginBottom: scale(2) }}
                meta={meta}
                clearInitialValue={clearInitialValue}
                onResetFilters={reset}
            />
            <Block>
                <Block.Body>
                    {renderHeader()}
                    <Table instance={table} />

                    {rows.length === 0 ? (
                        <TableEmpty
                            filtersActive={filtersActive}
                            titleWithFilters="Массовые операции с данными фильтрами не найдены"
                            titleWithoutFilters="Массовые операции отсутствуют"
                            onResetFilters={reset}
                        />
                    ) : (
                        <TableFooter
                            pages={totalPages}
                            itemsPerPageCount={itemsPerPageCount}
                            setItemsPerPageCount={setItemsPerPageCount}
                        />
                    )}
                </Block.Body>
            </Block>
        </PageWrapper>
    );
};

export default MassEditHistory;
